program fastdemo;
{$V-,f+}

uses crt,printer,dos,grp_mode,grp_writ,grp_draw,grp_mous,
     memdsk,om2_p3s,interact,plotvars,savepic,
     p3sbasic,lines,labeling,labdatpo,axes,intfline,funcplot,confip3s,
     grp_menu,grp_inp,
     olunit,
     fastpr24;

var error,laser,olhelp : boolean;
    dumchar : char;
    bits : array[0..16] of word;
    a : char;
    hw,fdkey : word;
    did : array[1..4] of boolean;
    i : integer;

function eutecticum(x : real) : real;
begin
  if x<0.43 then eutecticum:=450+sqrt((0.43-x)/0.43)*110
            else eutecticum:=450+sqrt((x-0.43)/0.57)*160
end;

procedure speed_comparison;
{lets you browse through the files on disk and print them}
const maxfiles = 50;
var curdia,i,delta,pc,grtb,ori,col,cmode,menu : integer;
    filename,errorstring : string80;
    a,ech,c1,c2 : char;
    notnew : boolean;
    options,options2,options3 : minichoiarr;
    pop3 : array[1..20] of ^string80;
    regs : registers;

procedure dump2disk;
begin
  i:=ord(FPGetDensity);
  i:=ord(FPGetColour);
  i:=FPGetCompressMode;

  gotoxy(2,1);
  pc:=pen_colour; pen_colour:=0;
  grtb:=grtextbackground; grtextbackground:=15;
  filename:=graph_strinp3(-wherex,-wherey,'DUMP filename [.DMP]: ',56,
              filename,file_tekens,c1,c2,[ReturnKey,EscKey],[],0,0);
  if positn('.',filename,1)=0 then concat(filename,'.dmp');
  if c1<>EscKey then {attempt to save}
    begin
    FPSetWindow(1,3,80,25);
    if PrintScreen2Disk(filename)<>0 then
      begin
      errorstring:=
'Error printing file. anykey...                                                    ';
      {strinp3 did the set_write_mode}
      write_graph(@errorstring,-2,-1,0,15);
      kbdscan(c1,c2)
      end
    end;
  pen_colour:=pc; grtextbackground:=grtb
end;
procedure draw_eutecticum;
var i : integer;
    x,y : real;
begin
  set_plot_area(pu,0,0,1,1,0.15,0.2,0.9,0.78,horizontal);
  initdevices(screen);

  set_global_window(0,1,440,630);
  an_axis(xaxis,ply(g3),g1,g2,0,0,0.4,0);
  an_axis(yaxis,plx(g1),g3,g4,0,0,0.4,0);
  an_axis(yaxis,plx(g2),g3,g4,0,0,0.4,0);
  label_axis('fraction Me^\1',xaxis,ply(g3),g1,g2,0,0,0.5,0.3,0.4);
  label_axis('',yaxis,plx(g1),g3,g4,0,0,0.5,0.3,0.4);
  gmovetoxy(percent,-20,80); glb('T^\melt',0.5,0.3,0);

  gnext_colour;
  plot_interval_lines:=true;
  plot_function_lines:=true;
  lin_funcplot(eutecticum,0,1,3,0.01,1,false,false,false,0);

  gmovetoxy(percent,10,110);
  hardlb('melt temperatures of mixtures of Me^\1^ and Me^\2^',1,1,0);

  gmovetoxy(pu,0,0);
  grtextbackground:=15;
  pen_colour:=0;
  hardlb('     minimal points required function plotting algorithm  by PP van Mierlo     ',1,1,0);
  gset_stand_colour;
  grtextbackground:=-1
end;
procedure draw_titration;
var i : integer;
    x,y : real;
    ph,v : array[1..101] of real;
{$I tit1.sub}
{$I tit2.sub}
begin
  set_plot_area(pu,0,0,1,1,0.15,0.2,0.9,0.78,horizontal);
  initdevices(screen);

  set_global_window(0,4,0,15);
  an_axis(xaxis,ply(g3),g1,g2,0,0,0.4,0);
  an_axis(yaxis,plx(g1),g3,g4,0,0,0.4,0);
  label_axis('ml titrant',xaxis,ply(g3),g1,g2,0,0,0.5,0.3,0.4);
  label_axis('',yaxis,plx(g1),g3,g4,0,0,0.5,0.3,0.4);
  gmovetoxy(percent,-15,85); glb('pH',0.5,0.3,0);

  gnext_colour;
  first_titration;
  gmovetoxy(world,v[1],ph[1]);
  for i:=2 to 101 do gplottoxy(world,v[i],ph[i]);
  gmovetoxy(percent,10,110);
  hardlb('10 ml 0.1M HCl, 0.1M HAc with 1.0M NaOH',0.5,0.3,0);

  gnext_colour;
  second_titration;
  gmovetoxy(world,v[1],ph[1]);
  for i:=2 to 101 do gplottoxy(world,v[i],ph[i]);
  gmovetoxy(percent,10,100);
  hardlb('10 ml 0.1M HCl, 0.1M HAc with 0.9M NaOH, 0.05M CO^\3^^2-',0.5,0.3,0);

  gmovetoxy(pu,0,0);
  grtextbackground:=15;
  pen_colour:=0;
  hardlb('          curves from  ulTItra titration programme  by PP van Mierlo          ',1,1,0);
  gset_stand_colour;
  grtextbackground:=-1
end;
procedure draw_diagram;
var i : integer;
    x,y : real;
begin
  set_plot_area(pu,0,0,1,1,0.15,0.2,0.9,0.78,horizontal);
  initdevices(screen);

  set_global_window(0,10,0,5);
  an_axis(xaxis,ply(g3),0,10,0,0,0.4,0);
  an_axis(yaxis,plx(g1),0,5,0,0,0.4,0);
  an_axis(yaxis,plx(g2),0,5,0,0,0.4,0);
  label_axis('time (fortnights)',xaxis,ply(g3),0,10,0,0,0.5,0.3,0.4);
  label_axis('',yaxis,plx(g1),0,5,0,0,0.5,0.3,0.4);
  gmovetoxy(percent,-20,105); glb('distance (furlongs)',0.5,0.3,0);

  init_points_table;

  gnext_colour;
  label_data_point(percent,30,114,3,0.15,empty,0);
  gmovetoxy(percent,35,110); glb('snail',0.5,0.15,0);
  for i:=1 to 10 do
    begin
    x:=(i-1+random); y:=(i/3)*(1.5+random)/2.5;
    label_data_point(world,x,y,3,0.15,empty,0);
    add_data_point(world,x,y,0.15)
    end;

  gnext_colour;
  label_data_point(percent,60,114,4,0.15,empty,0);
  gmovetoxy(percent,65,110); glb('turtle',0.5,0.15,0);
  for i:=1 to 10 do
    begin
    x:=(i-1+random); y:=(i/3)*(3+random)/2.5;
    label_data_point(world,x,y,4,0.15,empty,0);
    add_data_point(world,x,y,0.15)
    end;

  gnext_colour;
  interfered_line(world,0,0,10,3,1.5);
  gnext_colour;
  interfered_line(world,0,0,10,5,1.5);

  gmovetoxy(pu,0,0);
  grtextbackground:=15;
  pen_colour:=0;
  hardlb('    P3S scientific axis, line, point plotting routines  by PP van Mierlo      ',1,1,0);
  gset_stand_colour;
  grtextbackground:=-1
end;
procedure draw_quilt;
var i : integer;
    a : string80;
    old : screen_type;
begin
  old:=cur_screen; cur_screen:=ega;

  initdevices(screen);
  a:='quilt.pcx';
  i:=disk2screenpcx(0,@a,180,150,0,0);

  set_draw_mode(-1);
  for i:=1 to 15 do
    block_all(40*i-10,80,40*i+20,120,i);

  gmovetoxy(pu,0,0);
  grtextbackground:=15;
  pen_colour:=0;
  hardlb('    The "quilt" is also used for the EGA colour mask demo in the main menu    ',1,1,0);
  gset_stand_colour;
  grtextbackground:=-1;

  cur_screen:=old
end;
procedure restoreit;
begin
  if screen_pushed then grestore_sheet
  else
    case curdia of
      1 : draw_diagram;
      2 : draw_titration;
      3 : draw_eutecticum;
      4 : draw_quilt;
      else
      end
end;
procedure compressstuff;
var menu,i : integer;
begin
  for i:=1 to 7 do
    if (FPGetCompressMode and ipower(2,i-1))<>0 then options2[i][3]:='*'
                                                else options2[i][3]:=' ';

  i:=write_picture(41,272,trunc(12*spyr/25),512-272,trunc(12*spyr/25),true,true);
  menu:=1;
  repeat
    write3Dbutton(272,trunc(12*spyr/25),511,trunc(13.5*spyr/25),
                  menucurfore,menucurback,
                  'compress mode='+numtostring(FPGetCompressMode,0),false);
    menu:=graph_minimenu(35,15,30,options2,9,menu);
    if not (menu in [0,9]) then
      begin
      FPSetCompressMode(FPGetCompressMode xor ipower(2,menu-1));
      if (FPGetCompressMode and ipower(2,menu-1))<>0 then
        options2[menu][3]:='*'
      else
        options2[menu][3]:=' '
      end
  until menu in [0,9];
  i:=read_picture(41,272,trunc(12*spyr/25),512-272,trunc(12*spyr/25),true,true)
end;
procedure dumpstuff;
var menu,i : integer;
begin
  menu:=1;
  gpush_sheet;
  repeat
    menu:=graph_minimenu(1,2,30,options,18,menu);
    case menu of
      0 : restoreit;
      1 : begin restoreit; PrintScreen end;
      2 : begin restoreit; dump2disk end;
      4 : begin
        options[ori][1]:=' ';
        ori:=4;
        options[4][1]:='*';
        FPSetDensity(SingleDensity); FPSetOrientation(dump_horizontal)
        end;
      5 : begin
        options[ori][1]:=' ';
        ori:=5;
        options[5][1]:='*';
        FPSetDensity(DoubleDensity); FPSetOrientation(dump_horizontal)
        end;
      6 : begin
        options[ori][1]:=' ';
        ori:=6;
        options[6][1]:='*';
        FPSetDensity(quadDensity); FPSetOrientation(dump_horizontal)
        end;
      7 : begin
        options[ori][1]:=' ';
        ori:=7;
        options[7][1]:='*';
        FPSetDensity(SingleDensity); FPSetOrientation(dump_left)
        end;
      9 : begin
        options[col][1]:=' ';
        col:=9;
        options[9][1]:='*';
        FPSetColour(dump_nocolour)
        end;
     10 : begin
        options[col][1]:=' ';
        col:=10;
        options[10][1]:='*';
        FPSetColour(dump_colour)
        end;
      11: begin
        options[col][1]:=' ';
        col:=11;
        options[11][1]:='*';
        FPSetColour(dump_simulated)
        end;
      12: begin
        options[col][1]:=' ';
        col:=12;
        options[12][1]:='*';
        FPSetColour(dump_24pin) {also sets triple/double density}
        end;
      13: begin
        options[col][1]:=' ';
        col:=13;
        options[13][1]:='*';
        FPSetColour(dump_laser)
        end;
      15: compressstuff;
      16: begin
        i:=write_picture(41,0,0,639,2+trunc(spyr/25),true,true);
        gotoxy(1,1);
        pc:=pen_colour; pen_colour:=0;
        grtb:=grtextbackground; grtextbackground:=15;
        cmode:=FPGetSkipcount;
        cmode:=trunc(graph_feinp3(-wherex,-wherey,'Enter skip count: ',
                     0,1e20,0,cmode,c1,c2,[ReturnKey,EscKey],[],61,0));
        if c1<>EscKey then FPSetSkipcount(cmode);
        pen_colour:=pc; grtextbackground:=grtb;
        i:=read_picture(41,0,0,0,0,true,true)
        end;
      18: restoreit;
      else
      end
  until menu in [0,1,2,18]
end;
begin
  set3Dcolours;

  options[1]:='  Print Screen';
  options[2]:='  Print Screen to Disk';
  options[3]:='';
  options[4]:='  horizontal dumps';
  options[5]:='* horizontal double density';
  options[6]:='  horizontal quad density';
  options[7]:='  left oriented dumps';
  options[8]:='';
  options[9]:='  black & white dumps';
  options[10]:='  colour dumps';
  options[11]:='  simulate colours';
  options[12]:='  24pin matrix dump';
  options[13]:='  laser printer dump';
  options[14]:='';
  options[15]:='  set compress mode';
  options[16]:='  set space skip count';
  options[17]:='';
  options[18]:='  main menu';

  options2[1]:='    use spaces    (matrix)';
  options2[2]:='    use enlarge   (matrix)';
  options2[3]:='    use tabs      (matrix)';
  options2[4]:='    use dot tabs  (matrix)';
  options2[5]:='    use ESC*b#Y    (laser)';
  options2[6]:='    use TIFF       (laser)';
  options2[7]:='    use delta row  (laser)';
  options2[8]:='';
  options2[9]:='    ready';

  options3[1]:=' FASTDUMP';
  options3[2]:='native dump';
  options3[3]:='screen mode';
  options3[4]:=' next page';
  options3[5]:=' prev page';
  options3[6]:=' main menu';
  for i:=1 to 6 do pop3[i]:=@options3[i];

  filename:='';

  FPSetWindow(1,3,80,25);

  FPSetDensity(doubleDensity); FPSetCentered(true); ori:=5;

  case FPGetColour of
    dump_colour : col:=10;
    dump_nocolour : col:=9;
    dump_simulated : col:=11;
    dump_24pin : col:=12;
    else col:=13
    end;

  options[col][1]:='*';

  curdia:=1; notnew:=false;
  repeat
    if not notnew then
      case curdia of
        1 : draw_diagram;
        2 : draw_titration;
        3 : draw_eutecticum;
        4 : draw_quilt;
        else
        end;
    notnew:=false;

    menu:=megamenu(2,1,13,1,6,menuothfore,menuothback,menucurfore,menucurback,
                   @pop3,6,1,a,ech,[ReturnKey,EscKey],[],false,speed_comparison);
    if a<>EscKey then case menu of
      1 : begin notnew:=true; dumpstuff end;
      2 : intr(5,regs);
      4 : begin
        curdia:=curdia+1;
        if (curdia=4) and not test_mode(16) then curdia:=1;
        if curdia>4 then curdia:=1
        end;
      5 : begin
        curdia:=curdia-1;
        if curdia=0 then
        if test_mode(16) then curdia:=4
                         else curdia:=3
        end;
      3 : begin
        gpush_sheet;
        notnew:=not ask_screen(28,2);
        if notnew then restoreit
        end;
      else
        notnew:=true;
      end; {case menu}

  until (a=EscKey) or (menu in [0,6]);

  FPSetOrientation(dump_horizontal);
  FPSetCentered(false);
  FPSetShrink(autoshrink);
  FPSetDensity(singleDensity); {automatically also leaves 24 pin mode
                                but not laser mode}
  plotter_mode:=screen;
  un_install_device; set_normal_colours
end; {speed_comparison}


procedure preview_palette;
type vertaal_tabel = array[0..7] of byte;
const tabel : vertaal_tabel = (63,57,62,58,60,61,38,20);
var a : registers;
    black : array[1..4] of word;
    newpalette : array[0..16] of byte;
    i,j : integer;
begin
  {now read colour masks}
  FPGetEgamask(black[1],black[2],black[3],black[4]);
  for j:=0 to 15 do
    begin
    newpalette[j]:=0;
    for i:=1 to 4 do
      begin
      newpalette[j]:=2*newpalette[j];
      if (black[i] and bits[j])<>0 then inc(newpalette[j])
      end;
    if newpalette[j]>7 then newpalette[j]:=0
    else
      if FPGetColour<>dump_nocolour then newpalette[j]:=tabel[newpalette[j]]
                                    else newpalette[j]:=63
    end;
  newpalette[16]:=63;
  a.ah:=$10;
  a.al:=2;
  a.es:=seg(newpalette);
  a.dx:=ofs(newpalette);
  intr($10,a)
end;

procedure restore_palette;
var a : registers;
const newpalette : array[0..16] of byte =(
                     0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63,0);
begin
  a.ah:=$10;
  a.al:=2;
  a.es:=seg(newpalette);
  a.dx:=ofs(newpalette);
  intr($10,a)
end;

procedure int5proc;
interrupt;
begin
  FPSetWindow(1,1,40,11);
  PrintScreen;
  FPSetWindow(41,1,80,11);
  PrintScreen;
  FPSetWindow(5,12,56,13);
  PrintScreen
end;

procedure dummy;
begin end;

procedure egastuff;
var oldscreen : screen_type;
    filename : string[80];
    black : array[1..4] of word;
    i,j,im,jm,bu,co,ro : integer;
    oldint5 : pointer;
    options : minichoiarr;
    amouseareas : array[1..10] of amousearea;
    regs : registers;
procedure box_coors(i,j : integer; var x0,y0,x1,y1 : real);
begin
  y0:=350-185-30*i;
  x0:=(15-j)*25+48;
  y1:=y0+15;
  x1:=x0+17
end;
procedure drawblock(i,j : integer; dodraw : boolean);
var x0,y0,x1,y1 : real;
begin
  if dodraw then pen_colour:=j else pen_colour:=0;
  box_coors(i,j,x0,y0,x1,y1);
  if j<>0 then fill_box(world,x0,y0,x1,y1);
  if (j=0) and not dodraw then draw_box(world,x0,y0,x1,y1);
  pen_colour:=15;
  if (j=0) and dodraw then draw_box(world,x0,y0,x1,y1);
end;
procedure set_up_boxes;
var i,j : integer;
begin
  i:=0; for j:=0 to 15 do drawblock(i,j,true);
  gmovetoxy(world,0,152); hardlb('print:',0,0,0);
  gmovetoxy(world,0,138); hardlb('black',0,0,0);
  gmovetoxy(world,0,108); hardlb('red',0,0,0);
  gmovetoxy(world,0,78); hardlb('yellow',0,0,0);
  gmovetoxy(world,0,48); hardlb('blue',0,0,0);
  for i:=1 to 4 do
    for j:=0 to 15 do
      if (black[i] and bits[j])<>0 then drawblock(i,j,true)
end;
procedure outputAmask(i : integer);
var cl : string80;
    j : integer;
    y0 : real;
begin
  case i of 1:cl:='/EB'; 2:cl:='/ER'; 3:cl:='/EY'; 4:cl:='/EU'; end;
  for j:=15 downto 0 do
    if (black[i] and bits[j])<>0 then concat(cl,'1')
                                 else concat(cl,'0');
  {now label in mask and cl}
  grtextbackground:=0;
  y0:=350-185-30*i+9;
  gmovetoxy(world,450,y0); hardlb('mask='+numtostring(black[i],0)+'    ',0,0,0);
  gmovetoxy(world,450,y0-12); hardlb('cl: '+cl,0,0,0);
  grtextbackground:=-1
end;
procedure outputmasks;
var i : integer;
begin
  for i:=1 to 4 do outputAmask(i)
end;
procedure outputkeys;
var keys : string[4];
begin
  keys[0]:=chr(4); keys[1]:=chr(27); keys[2]:=chr(24);
                   keys[3]:=chr(26); keys[4]:=chr(25);
  gmovetoxy(world,0,0);
  hardlb('          <Return,Space> : toggle mask            <'+keys+'> : move',0,0,0);

  write3Dbutton(  0,325,127,339,menucurfore,menucurback,'print (PrtSc)',true);
  write3Dbutton(128,325,255,339,menucurfore,menucurback,'print mode (C)',true);
  write3Dbutton(256,325,383,339,menucurfore,menucurback,'preview (P)',true);
  write3Dbutton(384,325,511,339,menucurfore,menucurback,'main menu (ESC)',true);
  write3Dbutton(512,325,639,339,menucurfore,menucurback,'help (F1)',true);
  with amouseareas[1] do
    begin x0:=  0; y0:=325; x1:=127; y1:=339 end;
  with amouseareas[2] do
    begin x0:=128; y0:=325; x1:=255; y1:=339 end;
  with amouseareas[3] do
    begin x0:=256; y0:=325; x1:=383; y1:=339 end;
  with amouseareas[4] do
    begin x0:=384; y0:=325; x1:=511; y1:=339 end;
  with amouseareas[5] do
    begin x0:=512; y0:=325; x1:=639; y1:=339 end;
  with amouseareas[6] do
    begin x0:=48; y0:=185; x1:=48+16*25; y1:=305 end;

  pmouseareas:=@amouseareas; nummouseareas:=6 {set up mousing}
end;
procedure outputCsupport;
var t1,t2 : string80;
    i,k : integer;
begin
  case FPGetColour of
    dump_nocolour: begin
      t1:='NOT supporting colour printing'; t2:='/C- '
      end;
    dump_colour: begin
      t1:='    supporting colour printing'; t2:='/C+ '
      end;
    dump_simulated: begin
      t1:='    simulating colour printing'; t2:='/Cs '
      end;
    dump_24pin: begin
      t1:='      24 pin simulated colours'; t2:='/C3 '
      end;
    dump_laser: begin
      t1:='       LASER simulated colours'; t2:='/Cll'
      end
    end;
  t1:=t1+' cl: '+t2;
  grtextbackground:=0;
  gmovetoxy(world,450-8*(length(t1)-8),28);
  hardlb(t1,0,0,0);
  grtextbackground:=-1;
  FPGetEgamask(black[1],black[2],black[3],black[4]);
  outputAmask(1);
  for k:=15 downto 0 do drawblock(1,k,((black[1] and bits[k])<>0))
end;
procedure changemasks;
var i,j : integer;
    x0,y0,x1,y1 : real;
    a,ech,dum : char;
    options : minichoiarr;
procedure colourstuff;
var menu,i : integer;
begin
  i:=write_picture(41,272,trunc(12*spyr/25),512-272,trunc(12*spyr/25),true,true);
  case FPGetColour of
    dump_nocolour : menu:=1;
    dump_colour : menu:=2;
    dump_simulated : menu:=3;
    dump_laser : menu:=5;
    dump_24pin : menu:=4;
    else
      menu:=1
    end;
  write3Dbutton(272,trunc(12*spyr/25),511,trunc(13.5*spyr/25),
                menucurfore,menucurback,
                'select dump type:',false);
  nummouseareas:=0;
  menu:=graph_minimenu(35,15,30,options,5,menu);
  case menu of
    1: begin FPSetColour(dump_nocolour); FPSetDensity(doubleDensity) end;
    2: begin FPSetColour(dump_colour); FPSetDensity(doubleDensity) end;
    3: begin FPSetColour(dump_simulated); FPSetDensity(doubleDensity) end;
    4: begin FPSetColour(dump_24pin); FPSetDensity(doubleDensity) end;
    5: begin FPSetColour(dump_laser); FPSetDensity(quadDensity) end;
    else
    end;
  if menu<>0 then laser:=menu=5;
  nummouseareas:=6;
  i:=read_picture(41,272,trunc(12*spyr/25),512-272,trunc(12*spyr/25),true,true);
  outputCsupport
end;
begin
  options[1]:='B&W dot matrix';
  options[2]:='colour dot matrix';
  options[3]:='simulated colour dot matrix';
  options[4]:='24 pin simulated colour';
  options[5]:='LASER simulated colour';

  i:=1; j:=15;
  repeat
    box_coors(i,j,x0,y0,x1,y1);
    draw_box(world,x0-2,y0-2,x1+2,y1+2);

    wait4key_mouse(a,ech,[ReturnKey,SpaceKey,EscKey,'c','C','p','P'],
                   [CurLeftKey,CurRightKey,CurUpKey,CurDnKey,F1Key],
                   false,false,dummy);
      while mousepressed do;

    if mouseareaindex=0 then
      begin
      case a of
        'c','C': colourstuff;
        'p','P': begin
          preview_palette;
          anykeyormouse(dum,dum);
            while mousepressed do;
          restore_palette
          end;
        SpaceKey,ReturnKey : begin
          drawblock(i,j,((black[i] and bits[j])=0));
          black[i]:=black[i] xor bits[j];
          outputAmask(i);
          FPSetEgamask(black[1],black[2],black[3],black[4])
          end;
        EscKey : exit;
        chr(0) :
          case ech of
            F1Key: if olhelp then begin
              gpush_sheet;
              if 0=init_olhelp('quilt.hlp','quilt.pag','quilt.ind') then
                hyperhelp('',10);
              grestore_sheet
              end;
            CurUpKey : begin i:=i-1; if i=0 then i:=4 end;
            CurDnKey : begin i:=i+1; if i=5 then i:=1 end;
            CurLeftKey : begin j:=j+1; if j=16 then j:=0 end;
            CurRightKey : begin j:=j-1; if j=-1 then j:=15 end;
            else
            end; {case}
        else
        end {case}
      end
    else {mouseareaindex}
      begin
      case mouseareaindex of
        1: intr($5,regs);
        2: colourstuff;
        3: begin
          preview_palette;
          repeat until keypressed or (mouse_pos_stat(@bu,@ro,@co)<>0);
          oncekbdscan(dum,dum);
          restore_palette
          end;
        4: exit;
        5: if olhelp then begin
          gpush_sheet;
          if 0=init_olhelp('quilt.hlp','quilt.pag','quilt.ind') then
            hyperhelp('',10);
          grestore_sheet
          end;
        6: begin
          repeat until mouse_pos_stat(@bu,@co,@ro)=0;
          im:=(intermousey-7-185) div 30 + 1;
          jm:=15 - (intermousex+4-48) div 25;
          drawblock(im,jm,((black[im] and bits[jm])=0));
          black[im]:=black[im] xor bits[jm];
          outputAmask(im);
          FPSetEgamask(black[1],black[2],black[3],black[4])
          end
        else
        end
      end;

    pen_colour:=0;
    draw_box(world,x0-2,y0-2,x1+2,y1+2);
    pen_colour:=15;
  until false
end;
begin if there_array[ega] then begin
  set3Dcolours;

  oldscreen:=cur_screen;
  cur_screen:=ega; initdevices(screen);
  filename:='quilt.pic';
  if disk2screen(-1,@filename)=5 then
    begin
    (* draw_sines; {draws 15 sine curves in 15 colours} *)
    set_plot_area(pu,0,0,1,1,0,0,1,1,horizontal); {full screen}
    set_global_window(0,639,0,349); {screen coordinates}

    bits[0]:=1; for i:=1 to 15 do bits[i]:=2*bits[i-1]; {masks}

    FPGetEgamask(black[1],black[2],black[3],black[4]);
    (* set_up_boxes; *)
    (* outputmasks;  *)
    outputCsupport;
    outputkeys;

    GetIntVec(5,oldint5);
    FPSetDensity(doubleDensity);
    FPSetCentered(true);
    FPSetShrink(shrink3);
    SetIntVec(5,@int5proc);

    changemasks;

    FPSetShrink(autoshrink);
    FPSetCentered(false);
    FPSetWindow(1,1,80,24);
    FPSetDensity(singleDensity);
    SetIntVec(5,oldint5) {restore interrupt}
    end; {quilt loaded ok}
  un_install_device; cur_screen:=oldscreen; {restore screen type}
  set_normal_colours;
  pmouseareas:=nil; nummouseareas:=0
end {ega found} end; {egastuff}

procedure amessage(a : string80);
begin
  a:=copy(a+spaces(80),1,80);
  set_write_mode(-1,pwmsNULL);
  write_graph(@a,-1,-25,15,0)
end;

procedure amessageat(x,y : integer; a : string80);
begin
  set_write_mode(-1,pwmsNULL);
  write_graph(@a,-x,-y,15,0)
end;

procedure findkey;
var x,y : integer;
    a,ech : char;
begin
  winclrscr(1,2,80,25,11);
  gotoxy(1,5);
  writeln('FASTDUMP lets you define a special key that will invoke a screendump when');
  writeln('pressed together with the ALT key (first press ALT, then the FASTDUMP KEY).');
  writeln;
  write('You define the key using the commandline ');
  textcolor(14); writeln('FASTDUMP /Knnn'); textcolor(11);
  writeln;
  writeln('where nnn is the scan code of the key.');
  writeln;
  writeln('The scan code of any (usable) key that you press will now be displayed,');
  writeln('until you hit the ESC key (which has scan code 1).');
  writeln; writeln; writeln; writeln;
  writeln('                              Ŀ');
    write('                               ');
    textcolor(14); write('/K'); textcolor(11);
  x:=wherex; y:=wherey;
                                    writeln('    ');
  writeln('                              ');
  textcolor(14); killcursor;
  repeat
    kbdscan(a,ech);
    if a<>EscKey then
      begin
      fdkey:=ord(ech);
      gotoxy(x,y); write(copy(numtostring(ord(ech),0)+spaces(3),1,3))
      end
  until ech=chr(1);
  revivecursor
end;

procedure CRstuff;
var amouseareas : array[1..2] of amousearea;
    a,ech : char;
begin
  winclrscr(1,4,80,25,11);
  gotoxy(40,6); write('1');
  gotoxy(40,7); write('2');
  gotoxy(40,8); write('3');
  gotoxy(40,9); write('4');
  gotoxy(40,10); write('5');
  FPSetWindow(40,6,40,10);
  FPSetCR(false); PrintScreen; FPSetCR(not laser);
  FPSetWindow(1,1,80,25);
  if laser and printeronline(1) then write(lst,chr(12)); {form feed}

  gotoxy(1,12);
  writeln('How does this look on your printer ?');
  writeln;
  writeln('               Ŀ                             Ŀ');
  writeln('                1                                     1       ');
  writeln('                2                                      2      ');
  writeln('                3                                       3     ');
  writeln('                4                                        4    ');
  writeln('                5                                         5   ');
  writeln('                                            ');
  writeln;
  writeln('Click on the correct area or press L(eft or R(ight');

  with amouseareas[1] do
    begin x0:=14*8; y0:=13*8; x1:=26*8; y1:=21*8 end;
  with amouseareas[2] do
    begin x0:=53*8; y0:=13*8; x1:=65*8; y1:=21*8 end;

  pmouseareas:=@amouseareas; nummouseareas:=2; {set up mousing}

  wait4key_mouse(a,ech,['l','L','r','R'],[],false,false,CRstuff);

  if mouseareaindex=0 then FPSetCR(a in ['l','L'])
  else
    FPSetCr(mouseareaindex=1);

  pmouseareas:=nil; nummouseareas:=0
end;
procedure compressstuff;
var x,y,xm,ym,r,phi,stepphi : real;
    i,j,oldc,cur : integer;
    amouseareas : array[1..4] of amousearea;
    a,ech : char;
    bit : array[1..3] of integer;
procedure ticone(i,c : integer);
begin with amouseareas[i] do begin
  iswap(pen_colour,c);
  line_th(pu,x0/spxr,1-y0/spyr,x1/spxr,1-y1/spyr);
  line_th(pu,x0/spxr,1-y1/spyr,x1/spxr,1-y0/spyr);
  iswap(pen_colour,c)
end end;
begin
  set3Dcolours;

  bit[1]:=1; bit[2]:=4; bit[3]:=8;

  initdevices(screen);
  set_plot_area(pu,0,0,1,1,0,0,1,1,horizontal);
  set_global_window(0,spxrcm,0,spyrcm);

  amessageat(1,21,'The programme will make dumps of a window containing    ');
  amessageat(1,22,'an ellipse, applying several compression techniques.    ');
  amessageat(1,23,'When it is done, please indicate which ellipses were    ');
  amessageat(1,24,'indeed printed as an ellipse by clicking on the boxes   ');
  amessageat(1,25,'or using the cursor and space keys.                     ');

  for i:=1 to 3 do
    begin
    phi:=0; stepphi:=pi/30;
    xm:=spxrcm/4; ym:=(26-6*i)*spyrcm/25; r:=1.5;

    x:=xm+r*cos(phi); y:=ym+r*sin(phi); gmovetoxy(world,x,y);
    while phi<2*pi do
      begin
      phi:=phi+stepphi;
      x:=xm+r*cos(phi); y:=ym+r*sin(phi);
      gplottoxy(world,x,y);
      end;
    x:=xm+0.5*r*sqrt(2); y:=ym+0.5*r*sqrt(2); gmovetoxy(world,x,y);
    x:=xm-0.5*r*sqrt(2); y:=ym-0.5*r*sqrt(2); gplottoxy(world,x,y);
    x:=xm-0.5*r*sqrt(2); y:=ym+0.5*r*sqrt(2); gmovetoxy(world,x,y);
    x:=xm+0.5*r*sqrt(2); y:=ym-0.5*r*sqrt(2); gplottoxy(world,x,y)
    end;

  FPSetSkipcount(0); {make sure compressions are used}

  amessageat(40,1,' dumped      technique   compression');
  amessageat(40,2,'correctly ?                 code');

  set_amousearea(amouseareas[1],43,5,45,5);
  set_amousearea(amouseareas[2],43,11,45,11);
  set_amousearea(amouseareas[3],43,17,45,17);
  set_amousearea(amouseareas[4],70,22,77,23);

                amessageat(54,5, ' spaces           1');
                amessageat(54,11,'  tabs            4');
                amessageat(54,17,'dot tabs          8');
  for i:=1 to 3 do with amouseareas[i] do
    rechthoek(x0,y0,x1,y1,15);
  with amouseareas[4] do
    write3Dbutton(x0,y0,x1,y1,menucurfore,menucurback,'READY',false);

  for i:=1 to 3 do
    if (FPGetCompressmode and bit[i])<>0 then ticone(i,15);

  oldc:=FPGetCompressMode; FPSetDensity(singleDensity);
  FPSetWindow(1,3,40,8); FPSetCompressMode(3); PrintScreen;
  FPSetWindow(1,9,40,14); FPSetCompressMode(4); PrintScreen;
  FPSetWindow(1,15,40,20); FPSetCompressMode(8); PrintScreen;
  FPSetCompressmode(oldc);

  cur:=1;
  pmouseareas:=@amouseareas; nummouseareas:=4; {set up mousing}
  repeat
    with amouseareas[cur] do
      rechthoek(x0-2,y0-2,x1+2,y1+2,15);
    wait4key_mouse(a,ech,[ReturnKey,SpaceKey,EscKey],
                   [CurUpKey,CurDnKey],false,false,compressstuff);
    with amouseareas[cur] do
      rechthoek(x0-2,y0-2,x1+2,y1+2,0);

    if mouseareaindex<>0 then
      begin cur:=mouseareaindex; a:=ReturnKey; ech:=chr(0) end;

    case a of
      ReturnKey,SpaceKey: if cur<>4 then begin
        oldc:=oldc xor bit[cur];
        FPSetCompressMode(oldc);
        if (oldc and bit[cur])<>0 then ticone(cur,15)
                                  else ticone(cur,0)
        end;
      else
        case ech of
          CurUpKey: begin
            dec(cur); if cur=0 then cur:=4
            end;
          CurDnKey: begin
            inc(cur); if cur=5 then cur:=1
            end;
          else
          end
      end
  until (a=EscKey) or (a in [ReturnKey,SpaceKey]) and (cur=4);

  pmouseareas:=nil; nummouseareas:=0;

  un_install_device; set_normal_colours
end;
procedure compresslaser;
var x,y,xm,ym,r,phi,stepphi : real;
    i,j,oldc,cur : integer;
    amouseareas : array[1..4] of amousearea;
    a,ech : char;
    bit : array[1..3] of integer;
procedure ticone(i,c : integer);
begin with amouseareas[i] do begin
  iswap(pen_colour,c);
  line_th(pu,x0/spxr,1-y0/spyr,x1/spxr,1-y1/spyr);
  line_th(pu,x0/spxr,1-y1/spyr,x1/spxr,1-y0/spyr);
  iswap(pen_colour,c)
end end;
begin
  set3Dcolours;

  bit[1]:=16; bit[2]:=32; bit[3]:=64;

  initdevices(screen);
  set_plot_area(pu,0,0,1,1,0,0,1,1,horizontal);
  set_global_window(0,spxrcm,0,spyrcm);

  amessageat(1,21,'The programme will make dumps of windows containing     ');
  amessageat(1,22,'some test images, using several compression techniques. ');
  amessageat(1,23,'When it is done, please indicate which images were      ');
  amessageat(1,24,'printed correctly by clicking on the boxes              ');
  amessageat(1,25,'or using the cursor and space keys.                     ');

  {lots of empty lines}
  y:=22/25;
  while y>18/25 do
    begin
    line_th(pu,0.1,y,0.1+22/25-y,y);
    y:=y-3/spyr
    end;
  {nice tiffable image}
  y:=16/25;
  while y>12/25 do
    begin
    line_th(pu,0.1,y,0.1+16/25-y,y);
    y:=y-0.9/spyr
    end;
  {delta row stuff}
  fill_box(pu,0.1,10/25,0.1+4/25,6/25);

  amessageat(40,1,' dumped      technique   compression');
  amessageat(40,2,'correctly ?                 code');

  set_amousearea(amouseareas[1],43,5,45,5);
  set_amousearea(amouseareas[2],43,11,45,11);
  set_amousearea(amouseareas[3],43,17,45,17);
  set_amousearea(amouseareas[4],70,22,77,23);

                amessageat(54,5, ' ESC*b#Y         16');
                amessageat(54,11,'  TIFF           32');
                amessageat(54,17,'delta row        64');
  for i:=1 to 3 do with amouseareas[i] do
    rechthoek(x0,y0,x1,y1,15);
  with amouseareas[4] do
    write3Dbutton(x0,y0,x1,y1,menucurfore,menucurback,'READY',false);

  for i:=1 to 3 do
    if (FPGetCompressmode and bit[i])<>0 then ticone(i,15);

  oldc:=FPGetCompressMode; FPSetDensity(singleDensity);
  FPSetWindow(1,3,40,8); FPSetCompressMode(16); PrintScreen;
  FPSetWindow(1,9,40,14); FPSetCompressMode(32); PrintScreen;
  FPSetWindow(1,15,40,20); FPSetCompressMode(64);

  FPSetColour(dump_simulatedlaser); FPSetDensity(quadDensity);
  PrintScreen;
  FPSetColour(dump_laser);

  FPSetCompressmode(oldc);
  if printeronline(1) then write(lst,#12); {form feed}

  cur:=1;
  pmouseareas:=@amouseareas; nummouseareas:=4; {set up mousing}
  repeat
    with amouseareas[cur] do
      rechthoek(x0-2,y0-2,x1+2,y1+2,15);
    wait4key_mouse(a,ech,[ReturnKey,SpaceKey,EscKey],
                   [CurUpKey,CurDnKey],false,false,compressstuff);
    with amouseareas[cur] do
      rechthoek(x0-2,y0-2,x1+2,y1+2,0);

    if mouseareaindex<>0 then
      begin cur:=mouseareaindex; a:=ReturnKey; ech:=chr(0) end;

    case a of
      ReturnKey,SpaceKey: if cur<>4 then begin
        oldc:=oldc xor bit[cur];
        FPSetCompressMode(oldc);
        if (oldc and bit[cur])<>0 then ticone(cur,15)
                                  else ticone(cur,0)
        end;
      else
        case ech of
          CurUpKey: begin
            dec(cur); if cur=0 then cur:=4
            end;
          CurDnKey: begin
            inc(cur); if cur=5 then cur:=1
            end;
          else
          end
      end
  until (a=EscKey) or (a in [ReturnKey,SpaceKey]) and (cur=4);

  pmouseareas:=nil; nummouseareas:=0;

  un_install_device; set_normal_colours
end;
procedure spaceskipstuff;
var i,k,oldc,cur : integer;
    ii,j : real;
    amouseareas : array[1..5] of amousearea;
    a,ech : char;
    bit : array[1..4] of integer;
procedure ticone(i,c : integer);
begin with amouseareas[i] do begin
  iswap(pen_colour,c);
  line_th(pu,x0/spxr,1-y0/spyr,x1/spxr,1-y1/spyr);
  line_th(pu,x0/spxr,1-y1/spyr,x1/spxr,1-y0/spyr);
  iswap(pen_colour,c)
end end;
begin
  set3Dcolours;

  bit[1]:=0; bit[2]:=15; bit[3]:=35; bit[4]:=2000;

  initdevices(screen);
  set_plot_area(pu,0,0,1,1,0,0,1,1,horizontal);
  set_global_window(spx0,spx1,0,25);
  for k:=0 to 3 do
    begin
    j:=1; ii:=0;
    repeat
      line_th(world,ii,23-4*k,ii,25-4*k);
      ii:=ii+j; j:=2*j
    until j=256;
    j:=1; ii:=0;
    repeat
      line_th(world,ii,21-4*k,ii,23-4*k);
      ii:=ii+j; j:=1.3*j
    until ii>256
    end;

  amessageat(1,18,'The programme will print the test pattern setting the    ');
  amessageat(1,19,'lowest space skip count to 0, 15, 35 and a very high     ');
  amessageat(1,20,'value (where no spaces will be skipped).                 ');
  amessageat(1,22,'For the exact meaning of the lowest space skip count     ');
  amessageat(1,23,'please refer to the FASTDUMP/FASTPROC manuals. For now,  ');
  amessageat(1,24,'you should observe which is the lowest skip count at which');
  amessageat(1,25,'the print head moves smoothly, and click on its check box.');

  if laser and printeronline(1) then write(lst,#12); {form feed}

  amessageat(40,1,'dumped smoothly ?     space skip count');

  set_amousearea(amouseareas[1],47,3,49,3);
  set_amousearea(amouseareas[2],47,7,49,7);
  set_amousearea(amouseareas[3],47,11,49,11);
  set_amousearea(amouseareas[4],47,15,49,15);
  set_amousearea(amouseareas[5],70,22,77,23);

  for i:=1 to 4 do with amouseareas[i] do
    begin
    rechthoek(x0,y0,x1,y1,15);
    amessageat(70,3+4*(i-1),numtostring(bit[i],0))
    end;
  with amouseareas[5] do
    write3Dbutton(x0,y0,x1,y1,menucurfore,menucurback,'READY',false);

  oldc:=FPGetSkipcount; FPSetDensity(doubleDensity);
  for i:=1 to 4 do
    begin
    FPSetWindow(1,1+4*(i-1),35,3+4*(i-1));
    FPSetSkipcount(bit[i]);
    PrintScreen
    end;
  FPSetSkipcount(oldc);

  oldc:=1; while (FPGetSkipcount>bit[oldc]) and (oldc<4) do inc(oldc);
  ticone(oldc,15);

  cur:=1;
  pmouseareas:=@amouseareas; nummouseareas:=5; {set up mousing}
  repeat
    with amouseareas[cur] do
      rechthoek(x0-2,y0-2,x1+2,y1+2,15);
    wait4key_mouse(a,ech,[ReturnKey,SpaceKey,EscKey],
                   [CurUpKey,CurDnKey],false,false,compressstuff);
    with amouseareas[cur] do
      rechthoek(x0-2,y0-2,x1+2,y1+2,0);

    if mouseareaindex<>0 then
      begin cur:=mouseareaindex; a:=ReturnKey; ech:=chr(0) end;

    case a of
      ReturnKey,SpaceKey: if cur<>5 then begin
        ticone(oldc,0);
        FPSetSkipcount(bit[cur]);
        oldc:=cur;
        ticone(cur,15)
        end;
      else
        case ech of
          CurUpKey: begin
            dec(cur); if cur=0 then cur:=5
            end;
          CurDnKey: begin
            inc(cur); if cur=6 then cur:=1
            end;
          else
          end
      end
  until (a=EscKey) or (a in [ReturnKey,SpaceKey]) and (cur=5);

  pmouseareas:=nil; nummouseareas:=0;

  un_install_device; set_normal_colours
end;
procedure installation;
var menu,i : integer;
    options : minichoiarr;
    dum : char;
begin
  options[1]:='  determine if CR is required';
  options[2]:='  determine compress mode';
  options[3]:='  determine space skip count';
  options[4]:='  find FASTDUMP key';
  options[5]:='  main menu';

  repeat
    winclrscr(1,1,80,25,11);
    reverse_write;
    writeln('     FASTPROC/FASTDUMP printer dump demonstration programme  no c(0) 1990       ');
    writeln('     Printer installation menu                                                  ');
    normal_write;

    gotoxy(10,23); writeln('Current command line is:');
    gotoxy(10,25); textcolor(14);
    write('FASTDUMP ');
    if did[1] then
      if FPGetCR then write('/J+ ') else write('/J- ');
    if did[2] then
      write('/Z',FPGetCompressmode,' ');
    if did[3] then
      write('/Q',FPGetSkipcount,' ');
    if did[4] then
      write('/K',fdkey,' ');
    normal_write;

    for i:=1 to 4 do if did[i] then options[i][1]:='';

    gotoxy(20,8); write('Make your choice:');
    menu:=1; while did[menu] and (menu<5) do inc(menu);
    menu:=minimenu(15,10,50,options,5,menu);

    case menu of
      1: CRstuff;
      2: if laser then compresslaser
                  else compressstuff;
      3: if not laser then spaceskipstuff
         else
           begin
           sound(1000);
           gotoxy(10,18);
           textcolor(13);
           write('The space skip count is irrelevant on a laser printer. Anykey ...');
           normal_write;
           delay(300);
           nosound;
           repeat until keypressed or (mouse_pos_stat(@i,@i,@i)<>0);
           oncekbdscan(dum,dum)
           end;
      4: findkey;
      else
      end;
    did[menu]:=true

  until menu in [0,5]
end;

procedure dodemo;
var options : minichoiarr;
    menu : integer;
    a : char;
    dummy : boolean;
procedure set_option4;
begin
  if laser then options[4]:='change to dot matrix (now dumping LASER)'
           else options[4]:='change to LASER (now dumping dot matrix)'
end;
begin
  if laser then FPSetColour(dump_laser);

  options[1]:='gallery of test images';
  options[2]:='guide to printer installation';
  options[3]:='EGA colour mask demonstration';
  set_option4;
  options[5]:='quit';

  repeat
    winclrscr(1,1,80,25,11);
    reverse_write;
    write('  FASTPROC/FASTDUMP printer dump demonstration programme  no c(0) 1990, 1991    ');
    normal_write;

    gotoxy(20,8); write('Make your choice:');
    menu:=minimenu(15,10,50,options,5,1);
    case menu of
      1 : begin
        speed_comparison;
        if laser then FPSetColour(dump_laser)
                 else FPSetColour(dump_nocolour)
        end;
      2 : installation;
      3 : begin
        if not there_array[ega] then
          begin
          gotoxy(20,20); reverse_write;
          write('Sorry, no EGA found in this system ... (Anykey)'+spaces(80-wherex));
          kbdscan(a,a)
          end
        else
          egastuff
        end;
      4 : begin
        laser:=not laser;
        set_option4;
        if laser then FPSetColour(dump_laser)
                 else FPSetColour(dump_nocolour)
        end;
      else
      end
  until menu in [5];
end;


begin {main}
  for i:=1 to 4 do did[i]:=false; {which parts of commandline have been established}

  laser:=pos('laser',lowcs(paramstr(1)))<>0;
  fdkey:=55;

  init_plotting_system;

  winclrscr(1,1,80,25,11);
  textcolor(15); textbackground(13);
  write('     FASTPROC/FASTDUMP printer dump demonstration programme  no c(0) 1990       ');
  gotoxy(1,25);
  write('                 TIP: try hitting ESC to interrupt any printer dump            ');
  normal_write;
  gotoxy(1,4);
  writeln('This programme demonstrates some of the features of the FASTDUMP/FASTPROC');
  writeln('printer dump programmes and procedures.                                  ');
  writeln;
  writeln('FASTDUMP and FASTPROC excel in creating rapier fast copies of screens    ');
  writeln('on colour or B&W dot matrix printers, and on laser printers.             ');
  writeln;
  writeln('FASTDUMP is a stand-alone so-called TSR. When it is loaded it will stay   ');
  writeln('in memory, to be invoked by pressing the PrtSc key, or a user-defined    ');
  writeln('FASTDUMP key (cf. DOS GRAPHICS, which is lots slower though). We         ');
  writeln('recommend loading GRAPHICS before  you start FASTDEMO so you may compare ');
  writeln('dumping performance.                                                     ');
  writeln;
  writeln('FASTPROC is the linkable version of FASTDUMP. It may be included in      ');
  writeln('MS Pascal, Turbo Pascal, Quick Pascal, Quick BASIC, MSC and Turbo C++.   ');
  writeln('In fact, FASTDEMO is written in Turbo Pascal (and also TC++) using FASTPROC.');
  writeln;
  writeln;

  {load_rounding_table(error,'acctable.rtb');}
  {load_font('superfon.def',error);}
  label_mode:=hardware;
  FPSetOrientation(dump_horizontal);
  FPSetCR(true); {in case we're using a lser printer}
  FPGetPatterns(@bits);
  for i:=0 to 7 do
    begin hw:=bits[i]; bits[i]:=bits[15-i]; bits[15-i]:=hw end;
  FPSetPatterns(@bits);

  if not printeronline(1) then
    begin
    sound(1000);
    textcolor(14);
    writeln('Errors indicate the printer is off-line. Please make sure it is switched on.');
    textcolor(11);
    delay(50);
    nosound
    end
  else
    {PrintScreen;}
  writeln('Anykey ...'); kbdscan(a,a);

  olhelp:=online_memory(65536,512,100,200,10,50,10,50,0,10);

  dodemo;

  close_plotting_system;
  winclrscr(1,1,80,25,14);
  writeln('Feel free to distribute this demo, as long as you do not change it.');
  writeln;
  writeln('FASTDUMP and FASTPROC are available from');
  writeln;
  writeln('PP van Mierlo');
  writeln('Liesbergstraat 9');
  writeln('NL-5628 ED Eindhoven');
  writeln('The Netherlands');
  writeln;
  writeln('tel. x-31-40 41 19 45');
  writeln
end.
